jQuery(document).ready(function(){
    if (jQuery('#formbot_url').length) {
        var FormbotZoidComponent = zoid.create({
            tag: 'formbot-zoid-component',
            url: document.getElementById("formbot_url").value,
            dimensions: {
                width: '100%',
                height: '600px',
            },
        });

        FormbotZoidComponent({
            access_token: document.getElementById("formbot_access_token").value,
        }).render('#formbot_container');
    }

    //load formbot forms
    if (typeof window.formbot_forms !== 'undefined') {
        var data = {
            'action': 'formbot_get_forms',
        };
        jQuery.post(formbot_ajaxurl, data, function(response) {
            try {
                var forms = response.data;
                window.formbot_forms = forms;
            } catch (e) {
                console.log('Invalid formbot token')
            }
            
        })

        formbot_initialize_block(window.wp.blocks, window.wp.blockEditor, window.wp.element);
    }
})

function formbot_initialize_block( blocks, blockEditor, element ) {
    var el = element.createElement;
    var useBlockProps = blockEditor.useBlockProps;
    var BlockControls = blockEditor.BlockControls;
    var components = window.wp.components;

    blocks.registerBlockType( 'formbot-form-builder/form-picker', {
        title: 'Form Bot',
        icon: 'feedback',
        category: 'embed',

        supports: {
            align:true,
        },
 
        attributes: {
            form_url: {
                type: 'string',
                default: '',
            },
            selected_form: {
                type: 'string',
                default: '',
            }
        },
        edit: function(props) {

            var block = jQuery('div#block-' + props.clientId);
            var forms = window.formbot_forms !== '' ? window.formbot_forms : [];

            //if forms not loaded request to fetch
            if (window.formbot_forms == '') {
                block.find('.formbot-edit-div').append('<div class="formbot-loader"></div>');
                var data = {
                    'action': 'formbot_get_forms',
                };
                jQuery.post(formbot_ajaxurl, data, function(response) {
                    try{
                        var forms = response.data;
                        window.formbot_forms = forms;
                        for(var i in forms) {
                            block.find('.formbot-select-block select').append(jQuery("<option></option>")
                                .attr("value", forms[i].url)
                                .text(forms[i].name));
                            block.find('.formbot-select-block select').val(props.attributes.form_url);
                        }

                        block.find('.formbot-edit-div').find('.formbot-loader').remove();
                    } catch (e) {
                        console.log('Invalid formbot token')
                    }
                    
                })
            }

           var options = [{label: 'Select from existing forms', value: ''}];
           for(var i in forms) {
                options.push({label: forms[i].name, value: forms[i].url});
           }

           var hide_dropdown = props.attributes.form_url !== '' ? 'formbot-hide' : '';
           var hide_form = props.attributes.form_url == '' ? 'formbot-hide' : '';
           var blockProps = useBlockProps();
           return el( 'div',
              blockProps ,
              el(
                    BlockControls,
                    { key: 'controls' },
                    el( components.ToolbarButton, 
                        {
                            className: 'formbot-edit-btn',
                            onClick: function(){
                                block.find('.formbot-form-div').addClass('formbot-hide');
                                block.find('.formbot-edit-div').removeClass('formbot-hide');
                            },
                            title: 'Select form',
                            icon: 'edit-page'
                        }
                    ),
                    el( components.ToolbarButton, 
                        {
                            className: 'formbot-edit-btn',
                            onClick: function(){
                                if (props.attributes.selected_form !== '') {
                                    var form_token = '';
                                    var form_id = '';
                                    //set form toke
                                    for(var i in window.formbot_forms) {
                                        if (window.formbot_forms[i].url == props.attributes.selected_form) {
                                            form_token = window.formbot_forms[i].form_token;
                                            form_id = window.formbot_forms[i].id;
                                        }
                                    }
                                    var url = formbot_adminurl + '?page=formbot-form-builder&id=' + form_id + '&token=' + form_token;
                                    window.open(url, '_blank').focus();
                                } else {
                                    alert('No form selected');
                                }
                            },
                            title: 'Edit form',
                            icon: 'edit'
                        }
                    ),

                    el( components.ToolbarButton, 
                        {
                            className: 'formbot-edit-btn',
                            onClick: function(){
                                var iframe = document.getElementById('iframe-' + props.clientId);
                                iframe.src = iframe.src;
                            },
                            title: 'Refrsh form',
                            icon: 'image-rotate'
                        }
                    )
                ),
                [
                    el(
                        'div',
                        {
                            className: 'formbot-edit-div ' + hide_dropdown
                        },

                        el(
                            'h4',
                            { className: 'formbot-h4'},
                            'Form Bot - Select form'
                        ),
                        el(
                            wp.components.SelectControl,
                            {
                                value: props.attributes.selected_form,
                                options: options,
                                className: 'formbot-select-block',
                                onChange: function( value ) {
                                    props.setAttributes( { selected_form: value } );
                                },
                            }
                        ),
                        el(
                            'div',
                            {
                                style: {display: 'flex'}
                            },
                            el(
                                'button',
                                { 
                                    className: 'components-button is-primary',
                                    style: {marginLeft: 'auto'},
                                    onClick: function(){
                                        props.setAttributes( { form_url: props.attributes.selected_form } );
                                        if (props.attributes.form_url == '') {
                                            block.find('.formbot-form-div').addClass('formbot-hide');
                                            block.find('.formbot-edit-div').removeClass('formbot-hide');
                                        } else {
                                            block.find('.formbot-form-div').removeClass('formbot-hide');
                                            block.find('.formbot-edit-div').addClass('formbot-hide');
                                        }
                                    }
                                },
                                'Preview Form'
                            ),
                        )
                    ),
                    el(
                        'div',
                        {
                            className: 'formbot-form-div ' + hide_form
                        },
                        el( 
                            'iframe', 
                            {
                                src: props.attributes.form_url, 
                                width: '100%', 
                                height: 539, 
                                className: 'form-bot-iframe',
                                sandbox: 'allow-same-origin allow-scripts',
                                scrolling: "no",
                                frameborder: "0",
                                id: 'iframe-' + props.clientId,
                                onLoad: function(event){
                                    jQuery(event.target).closest('.formbot-form-div').find('.formbot-loader').remove();
                                }
                            }
                        ),

                        el(
                            'div',
                            {
                                className: 'formbot-overlay-div'
                            }
                        ),
                        el(
                            'div',
                            {
                                className: 'formbot-loader'
                            }
                        )
                    ),
              ]
           ); // End return

        },  // End edit()
 
        save: function(props) {
            // How our block renders on the frontend
            var blockProps = blockEditor.useBlockProps.save();

            return props.attributes.form_url ? el('div', 
                    blockProps,
                    el( 
                        'iframe', 
                        {
                            src: props.attributes.form_url, 
                            width: '100%', 
                            height: 539, 
                            sandbox: 'allow-same-origin allow-scripts',
                            frameborder: "0",
                        }
                    )
                )
                : el( 'p', {}, 'No form selected' );
           
        } // End save()
    });
}