/*
    Plugin Name: Formbot Form Builder
    Plugin URI: https://www.formbot.com
    Description:
    Version: 1.0.0
    Author: formbot.com
    Author URI: https://www.formbot.com
    License: GNU General Public License v3
*/

(function() {
    tinymce.create('tinymce.plugins.Formbot', {
        init : function(ed, url) {
            ed.addButton('formbot_form_picker', {
                title : 'Formbot',
                image : url+'/../images/form-bot.png',
                onclick : function(event) {
                    event.preventDefault();
                    open_formbot_modal()
                }
            });
        },
        createControl : function(n, cm) {
            return null;
        },
        getInfo : function() {
            return {
                longname : "Formbot Form Builder",
                author : 'formbot.com',
                authorurl : 'https://www.formbot.com',
                infourl : 'https://www.formbot.com',
                version : "1.0.0"
            };
        }
    });
    tinymce.PluginManager.add('formbot', tinymce.plugins.Formbot);

})();

function open_formbot_modal() {
    var data = {
            'action': 'formbot_get_forms',
        };
        jQuery.post(formbot_ajaxurl, data, function(response) {
            var forms = response.data;
            var modal = document.createElement("div");
            var modal_background_element = jQuery(document.createElement("div"));

            jQuery(modal_background_element).appendTo(jQuery("body")).attr("id", "modal_background").fadeIn(100);
            
            jQuery(modal).appendTo(jQuery("body")).attr("id","formbot_modal");

            var modal_html = '<button type="button" id="formBotCloseButton"><div><svg viewBox="0 0 18 18" fill="none" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" clip-rule="evenodd" d="M17.1 16.128l-6.75-6.803 6.75-6.802a.967.967 0 000-1.36.95.95 0 00-1.35 0L9 7.965 2.25 1.163a.95.95 0 00-1.35 0 .968.968 0 000 1.36l6.75 6.802L.9 16.128a.967.967 0 000 1.36.95.95 0 001.35 0L9 10.686l6.75 6.802a.95.95 0 001.35 0 .967.967 0 000-1.36z" fill="#8586A6"></path></svg></div></button>';


            modal_html += '<h2 class="formbot-header">Select Form</h2><p>Please select one of your form to continue</p>';

            var dropdown = '<select id="formbotFormDropdown">';
            dropdown += '<option value="">Select a form</option>';
            for(var i in forms) {
                dropdown += '<option value="' + forms[i].url + '">' + forms[i].name + '</option>';
            }
            dropdown += '</select>';

            modal_html += dropdown;

            modal_html += '<div id="wizardFooter"><button type="button" id="formbotContinueBtn">Continue</button></div> '
            jQuery('#formbot_modal').append(modal_html);

            var modal = jQuery(modal);
            modal.css("top", ( jQuery(window).height() - modal.height() ) / 2 + jQuery(window).scrollTop() + "px");
            modal.css("left", ( jQuery(window).width() - modal.width() ) / 2 + jQuery(window).scrollLeft() + "px");
        });
}

jQuery(document).on('click', '#formBotCloseButton', function(){
    closeFrombotModal();
})

jQuery(document).on('click', '#formbotContinueBtn', function(){
    if (jQuery('#formbotFormDropdown').val() != '') {
        var value = jQuery('#formbotFormDropdown').val();
        tinyMCE.activeEditor.execCommand('mceInsertContent', 0, value);
        closeFrombotModal();
    }
});

function closeFrombotModal() {
    jQuery('#formbot_modal').remove();
    jQuery('#modal_background').fadeOut(100, function(){
        jQuery('#modal_background').remove();
    });
}


